<template>
    <section class="carApply" style="margin-bottom:50px">
        <flash-message class="myCustomClass"></flash-message>
            <div class="first_step">

                <div class="form-group float-label-control" id="makeDiv">

                    <label>Car Make</label>
                    <select v-model="vehicle.make_id" class="form-control"  required @change="getModels">
                        <option selected disabled>Select Car Make</option>
                        <option v-for="make in cars" :value="make.iMakeId">{{ make.vMake }}</option>
                    </select>
                </div>
                <div class="form-group float-label-control">
                    <label>Car Model</label>
                    <select v-model="vehicle.model_id" class="form-control"  @change="getTypes" required placeholder="Select Model">

                        <option v-for="model in models" :value="model.iModelId">{{ model.vTitle }}</option>
                    </select>
                </div>
                <div class="form-group float-label-control">
                    <label>Car Type</label>
                    <select v-model="vehicle.type_id" class="form-control" @change="getColors" required placeholder="Select Type">
                        <option v-for="type in types" :value="type.iCarTypeId">{{ type.vTitle_EN }}</option>
                    </select>
                </div>
                <div class="form-group float-label-control">
                    <label>Car Color</label>
                    <select v-model="vehicle.color_id"  class="form-control" @change="getYears"  required>
                        <option v-for="color in colors" :value="color.iColourId">{{ color.vColour_EN }}</option>
                    </select>
                </div>
                <div class="form-group float-label-control">
                    <label>Car Year</label>
                    <select v-model="vehicle.year" class="form-control"  @change="checkInputs" required>
                        <option v-for="year in years" :value="year">{{ year }}</option>
                    </select>
                </div>

                <div class="form-group float-label-control" >
                    <label> License Plate </label>
                    <input @change="checkInputs" v-model="vehicle.vehicle_tag" type="text"  name="vehicle_tag" class="form-control" required>
                </div>
                <!--
                <button class="btn btn-primary"  :disabled="firstStep" @click.prevent="slideNext">		Continue
                </button> -->

                <div class="row">

                    <div class="col-md-6 col-12">
                        <div class="form-group float-label-control" >
                            <p> Driver's License </p>
                            <img :src="vehicle.driver_license" class="img-response" style="max-width: 200px;">
                            <carUploader modal="uploadLicense" url="/dashboarduser/saveLicense" 
                             v-bind:avatar.sync="vehicle.driver_license"></carUploader>
                        </div>
                    </div>
                    <div class="col-md-6 col-12">
                        <div class="form-group float-label-control" >
                            <p> Car Image </p>
                            <img :src="vehicle.path_image" class="img-response" style="max-width: 200px;">
                            <cropperUpload modal="uploadCar" url="/dashboarduser/saveCarImage"></cropperUpload>

<!--&lt;!&ndash;                            <carUploader  v-bind:avatar.sync="vehicle.path_image"></carUploader>&ndash;&gt;-->
                        </div>
                    </div>

                </div>

                <div class="row">
                    <div class="col-md-6 col-12">
                        <div class="form-group float-label-control" >
                            <p> Registration  </p>
                            <img :src="vehicle.registration_path" class="img-response" style="max-width: 200px;">
                            <carUploader modal="uploadRegistration" url="/dashboarduser/saveRegistration" v-bind:avatar.sync="vehicle.path_image"></carUploader>
                        </div>
                    </div>
                    <div class="col-md-6 col-12">
                        <div class="form-group float-label-control" >
                            <p> Insurance </p>
                            <img :src="vehicle.insurance_path" class="img-response" style="max-width: 200px;">
                            <carUploader modal="uploadInsurance" url="/dashboarduser/saveInsurance" v-bind:avatar.sync="vehicle.path_image"></carUploader>
                        </div>
                    </div>
                </div>

                <button @click="updateCar" class="btn btn-primary"> Update </button>

            </div>


    </section>
</template>

<script>

    export default {
        name: "changecar",
        props:['usercar', 'vehicles'],
        components:{},
        mounted() {
            console.log(this.vehicle);
            $('#loading').show();
            this.getYears();
            this.getModels();
            this.getTypes();
            this.getColors();
            $('#loading').hide();

        },
        data(){
            return{
                cars: JSON.parse(this.vehicles),
                vehicle:JSON.parse(this.usercar),
                models:'',
                types:'',
                colors:'',
                years:[],
            }
        },
        methods:{
            checkInputs:function(){
                if(this.vehicle.make_id != null && this.vehicle.model_id != null && this.vehicle.type_id != null &&
                    this.vehicle.color_id != null && this.vehicle.year != null && this.vehicle.vehicle_tag != null){
                }
            },
            getYears(){
                var temp = [];
                for(var i=0; i < 60; i++){
                    temp[i] = (2019 - i);
                }
                this.years = temp;
            },
            getModels(){

                axios.post('/dashboarduser/fetchModel', {

                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    'make':this.vehicle.make_id

                }).then(response => {
                    this.models = response.data;

                }).catch(e => {
                    this.errors.push(e)
                })
                this.checkInputs();
            },
            getTypes(){
                axios.post('/dashboarduser/fetchType', {

                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),


                }).then(response => {
                    this.types = response.data;

                }).catch(e => {
                    this.errors.push(e)
                })
                this.checkInputs();
            },
            getColors(){
                axios.post('/dashboarduser/fetchColor', {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),

                }).then(response => {
                    this.colors = response.data;

                }).catch(e => {
                    this.errors.push(e)
                });
                this.checkInputs();
            },
            updateCar(){
                jQuery('#loading').show();
                axios.put('/dashboarduser/updateDriver', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'vehicle' : this.vehicle,
                    }
                }).then(response => {
                    jQuery('html, body').animate({ scrollTop: 175 }, 'slow');
                    this.flash(response.data['message'], response.data['status'],{timeout: 3000});
                    jQuery('#loading').hide();

                }).catch(e => {
                    jQuery('html, body').animate({ scrollTop: 175 }, 'slow');
                    this.flash('Server 500 error please try again', 'error',{timeout: 3000});
                    console.log(e);
                    jQuery('#loading').hide();
                })
            },

            onFileChanged(event) {
                // Reference to the DOM input element
                var input = event.target;

                // Ensure that you have a file before attempting to read it
                if (input.files && input.files[0]) {
                    // create a new FileReader to read this image and convert to base64 format
                    var reader = new FileReader();
                    // Define a callback function to run, when FileReader finishes its job
                    reader.onload = (e) => {
                        // Note: arrow function used here, so that "this.imageData" refers to the imageData of Vue component
                        // Read image as base64 and set to imageData
                        this.vehicle.car = e.target.result;
                        this.showCropper = true;
                    }
                    // Start the reader job - read file as a data url (base64 format)
                    reader.readAsDataURL(input.files[0]);
                }
            },
            cropped(){
                const {coordinates, canvas} = this.$refs.cropper.getResult();
                this.coordinates = coordinates;
                // You able to do different manipulations at a canvas
                // but there we just get a cropped image
                this.$refs.cropper.setCoordinates({
                    width: coordinates.width,
                    height: coordinates.height,
                    left: coordinates.left,
                    top: coordinates.top
                });
                this.image = canvas.toDataURL();
                this.crop = true;
                this.notCropped = false;
                this.showCropper=false;
            },
        }
    }
</script>

<style scoped>

</style>